<template>
  <div v-if="ownParticipant" class="sw-gs-video-actions-wrapper">
    <div class="sw-gs-video-actions-wrapper-inner">

      <div class="sw-gs-guide-actions-wrapper">
        <template v-if="microphoneCount > 0">
          <SwButton class="sw-gs-video-guide-sound-toggle color-light is-circle"
                    @click="toggleMicrophone()"
                    :title="microphoneState === false ? $t('Unmute') : $t('Mute')"
                    :class="{ 'microphone-off': microphoneState === false }">
            <SwGsIconMicOff v-if="microphoneState === false" class="color-dark-secondary size-sm"/>
            <SwGsIconMicOn v-else class="color-dark-secondary size-sm"/>
          </SwButton>
        </template>


        <template v-if="videoChatEnabled && !isAudioOnly && cameraCount > 0">
          <SwButton class="sw-gs-video-guide-video-toggle color-light is-circle"
                    @click="toggleCamera()"
                    :title="cameraState === false ? $t('Video on') : $t('Video off')"
                    :class="{ 'camera-off': cameraState === false }">
            <SwGsIconCameraOff v-if="cameraState === false" class="color-dark-secondary size-sm"/>
            <SwGsIconCameraOn v-else class="color-dark-secondary size-sm"/>
          </SwButton>
        </template>

        <template v-if="hasDevices() && isSideBarOpen && !deviceError">
          <SwButton class="sw-gs-device-settings-toggle color-light is-circle" @click="toggleDeviceSettings">
            <SwGsIconCog class="color-dark-secondary size-sm"></SwGsIconCog>
          </SwButton>
        </template>

        <SwGsEndAppointment/>
      </div>

      <div class="sw-gs-client-actions-wrapper">
        <template v-if="hasMembers">
          <template v-if="isFullscreenVideoModalOpen">
            <SwButton class="sw-gs-open-fullscreen-modal-action is-circle color-light"
                      :title="$t('Toggle fullscreen')"
                      @click="toggleFullscreenVideoModal(false)">
              <SwGsIconCompress class="color-dark-secondary size-sm"/>
            </SwButton>
          </template>
          <template v-else>
            <SwButton class="sw-gs-open-fullscreen-modal-action is-circle color-light"
                      :title="$t('Toggle fullscreen')"
                      @click="toggleFullscreenVideoModal(true)">
              <SwGsIconExpand class="color-dark-secondary size-sm"/>
            </SwButton>
          </template>
        </template>

        <SwButton class="sw-gs-broadcast-toggle is-circle color-light"
                  :class="{'is-off': !isBroadCastEnabled}"
                  :title="isBroadCastEnabled ? $t('Broadcast mode is active') : $t('Broadcast mode is inactive')"
                  @click="toggleBroadcastMode">
          <SwGsIconBroadcast class="size-sm"/>
        </SwButton>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
  import SwButton from "@/components/atoms/SwButton.vue";
  import {
    SwGsIconBroadcast,
    SwGsIconCameraOff,
    SwGsIconCameraOn,
    SwGsIconClient,
    SwGsIconCog,
    SwGsIconCompress,
    SwGsIconExpand,
    SwGsIconMicOff,
    SwGsIconMicOn,
    SwGsIconPhoneOff,
    SwGsIconPhoneOn
  } from "../icons";

  import SwGsEndAppointment from '../SwGsEndAppointment.vue';
  import {useUIState} from "@shopware-pwa/composables";

  export default {
    name: "SwGsLayerVideoActions",
    components: {
      SwButton,
      SwGsIconBroadcast,
      SwGsIconExpand,
      SwGsIconCog,
      SwGsIconClient,
      SwGsIconCompress,
      SwGsEndAppointment,
      SwGsIconMicOff,
      SwGsIconMicOn,
      SwGsIconCameraOn,
      SwGsIconCameraOff,
      SwGsIconPhoneOn,
      SwGsIconPhoneOff,
    },
    props: {
      callData: {
        type: Object,
      }
    },
    setup(props) {
      const {switchState: toggleFullscreenVideoModal} = useUIState({stateName: "GS_VIDEO_FULLSCREEN_MODAL_STATE"});

      return {
        ...props.callData,
        toggleFullscreenVideoModal
      };
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-video-actions-wrapper {
    position: absolute;
    width: 100%;
    height: 40px;
    bottom: -45px;

    .sw-gs-video-actions-wrapper-inner {
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      padding: var(--spacer-xs);
    }

    .sw-gs-guide-actions-wrapper,
    .sw-gs-client-actions-wrapper {
      display: flex;
      flex-direction: row;
    }

    .sw-gs-video-guide-sound-toggle,
    .sw-gs-video-guide-video-toggle {
      margin-right: var(--spacer-xs);
    }

    .sw-gs-open-fullscreen-modal-action {
      display: none;

      @include for-tablet {
        display: block;
      }
    }

    ::v-deep .sw-gs-end-presentation {
      margin-left: var(--spacer-xs);
    }

    .sw-gs-broadcast-toggle {
      margin-left: var(--spacer-xs);
      --icon-color: var(--c-success);

      &.is-off {
        --icon-color: var(--c-danger);
      }
    }
  }

</style>
